#include <bits/stdc++.h>
using namespace std;

#define rep(i,a,b) for(int i=a;i<(b);++i)
#define all(x) begin(x), end(x)
#define sz(x) (int)(x).size()
typedef long long ll;
typedef pair<int,int> pii;
typedef vector<int> vi;

#define pb push_back
#define ff first
#define ss second

void drive(ll i){
	cout<<"DRIVE "<<i<<'\n';
}

void pickup(){
	cout<<"PICKUP\n";
}

void drop(){
	cout<<"DROPOFF\n";
}

ll stoi(char c){
	if(c=='-') return 0;
	if(c=='C') return 1;
	if(c=='M') return 2;
}

ll itos(int c){
	if(c==0) return '-';
	if(c==1) return 'C';
	if(c==2) return 'M';
}

vi eulerWalk(vector<vector<pii>> &gr, int nedges, int src){
	int n=sz(gr);
	vi D(n), its(n), eu(nedges), ret, s={src};
	D[src]++;
	while(!s.empty()){
		int x=s.back(),y , e, &it =its[x], end=sz(gr[x]);
		if(it==end) {ret.pb(x); s.pop_back(); continue;}
		tie(y, e)=gr[x][it++];
		if(!eu[e]){
			D[x]--; D[y]++;
			eu[e]=1;
			s.pb(y);
		}
	}
	for(int x: D) if(x<0 || sz(ret) !=nedges+1) return {};
	return {ret.rbegin(), ret.rend()};
}

void solve(){
	ll n; cin>>n;
	
	string a, b; cin>>a>>b;
	
	map<pair<char, char>, vector<ll>> mapi;
	
	rep(i,0,n){
		mapi[{a[i], b[i]}].pb(i);
	}
	
	ll m0=0, m1=0, c0=0, c1=0;
	/*
	for(char u: a){
		if(u=='M') m0++;
		if(u=='C') c0++;
	}
	
	for(char u: b){
		if(u=='M') m1++;
		if(u=='C') c1++;
	}*/
	
	ll gm=0;
	ll gc=0;
	
	rep(i,0,n){
		if(a[i]=='M') gm++;
		if(a[i]=='C') gc++;
		if(b[i]='C' && a[i]!='-') gc--;
		if(a[i]!='-' && b[i]=='M') gm--;
	}
	
	vector adj(3, vector<pii>());
	
	ll cc=0;
	
	for(ll u: mapi[{'M', 'C'}]){adj[stoi('M')].pb({stoi('C'), cc}); cc++;}
	for(ll u: mapi[{'C', 'M'}]){adj[stoi('C')].pb({stoi('M'), cc}); cc++;}
	for(ll u: mapi[{'M', '-'}]){adj[stoi('M')].pb({stoi('-'), cc}); cc++;}
	for(ll u: mapi[{'C', '-'}]){adj[stoi('C')].pb({stoi('-'), cc}); cc++;}
	
	map<pair<char, char>, vector<ll>> mapi2=mapi;
	
	rep(i, 0, gm){
		adj[stoi('-')].pb({stoi('M'), cc});
		cc++;
	}
	
	rep(i, 0, gc){
		adj[stoi('-')].pb({stoi('C'), cc});
		cc++;
	}
	/*
	rep(i, 0, 3){
		cout<<i<<' ';
		for(auto y: adj[i]) cout<<y.first<<' ';
		cout<<endl;
	}
	
	rep(i, 0, 3){
		assert((adj[i].size()%2)==0);
	}*/
	
	vi h=eulerWalk(adj, cc, 0);
	
	mapi=mapi2;
	
	ll hh=h.size();
	
	ll ff=0, kk=0;
	
	vector<pair<char, ll>> ans;
	/*
	for(ll u: h) cout<<u;
	cout<<endl;*/
	
	rep(i, 0, hh-1){
		if(mapi[{itos(h[i]), itos(h[i+1])}].empty()) {kk++; continue;}
		
		ll u=mapi[{itos(h[i]), itos(h[i+1])}].back();
		mapi[{itos(h[i]), itos(h[i+1])}].pop_back();
		
		if(ff==0){
			ans.pb({'d', u+1});
			
		}else{
			ans.pb({'p', u+1});
			ans.pb({'d', u+1});
			ans.pb({'m', u+1});
		}
		
		ff=1;
	}
	
	assert(kk<=1);
	
	cout<<ans.size()<<'\n';
	
	for(auto [c, u] : ans){
		if(c=='p') pickup();
		if(c=='d') drive(u);
		if(c=='m') drop();
	}
}


int main(){
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	cout<<fixed<<setprecision(12);
	
	solve();
}

